-- BatmanStoreFilter
--  (trtt)
--
--
--        _==/          i     i          \==_
--      /XX/            |\___/|            \XX\
--    /XXXX\            |XXXXX|            /XXXX\
--   |XXXXXX\_         _XXXXXXX_         _/XXXXXX|
--  XXXXXXXXXXXxxxxxxxXXXXXXXXXXXxxxxxxxXXXXXXXXXXX
-- |XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX|
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- |XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX|
--  XXXXXX/^^^^"\XXXXXXXXXXXXXXXXXXXXX/^^^^^\XXXXXX
--   |XXX|       \XXX/^^\XXXXX/^^\XXX/       |XXX|
--     \XX\       \X/    \XXX/    \X/       /XX/
--        "\       "      \X/      "      /"
--
--


-- Onurtag: Added trait stones. 
-- Addon ver: 0.01
--
--	╔═╗┌┐┌┬ ┬┬─┐┌┬┐┌─┐┌─┐
--	║ ║││││ │├┬┘ │ ├─┤│ ┬
--	╚═╝┘└┘└─┘┴└─ ┴ ┴ ┴└─┘
--


-- Author: Mitsarugi
-- Version: 0.01
-- Patch for: BatmanStoreFilter ( http://www.esoui.com/downloads/info193-BatmanStoreFilter.html )
-- Details: Adds all item type filters to the Guild Store


local BatmanFilter = ZO_TradingHouseMultiFilter:Subclass()

function BatmanFilter:New(...)
    return ZO_TradingHouseMultiFilter.New(self, ...)
end

function BatmanFilter:Initialize(parentControl)
    local control = CreateControlFromVirtual("$(parent)BatmanContainer", parentControl, "TradingHouseSingleComboFilter")
    ZO_TradingHouseMultiFilter.Initialize(self, control)

    local typeData =
    {
          
		{ ITEMTYPE_ADDITIVE, nil, "Additive" }, 
		{ ITEMTYPE_ALCHEMY_BASE, nil, "Alchemy (Base)" },
		{ ITEMTYPE_REAGENT, nil, "Alchemy (Reagent)" },
		{ ITEMTYPE_ARMOR, nil, "Armor" },
		{ ITEMTYPE_ARMOR_BOOSTER, nil, "Armor (Booster)" },
		{ ITEMTYPE_GLYPH_ARMOR, nil, "Armor (Glyph)" },		
		{ ITEMTYPE_ARMOR_TRAIT, nil, "Armor (Trait Stone)" },
		{ ITEMTYPE_BLACKSMITHING_BOOSTER, nil, "Blacksmithing (Booster)" },
		{ ITEMTYPE_BLACKSMITHING_MATERIAL, nil, "Blacksmithing (Material)" },
        { ITEMTYPE_BLACKSMITHING_RAW_MATERIAL, nil, "Blacksmithing (Raw Material)" },
		{ ITEMTYPE_CLOTHIER_BOOSTER, nil, "Clothing (Booster)" },
        { ITEMTYPE_CLOTHIER_MATERIAL, nil, "Clothing (Material)" },
        { ITEMTYPE_CLOTHIER_RAW_MATERIAL, nil, "Clothing (Raw Material)" },
		{ ITEMTYPE_COLLECTIBLE, nil, "Collectible" },
		{ ITEMTYPE_CONTAINER, nil, "Container" },
		{ ITEMTYPE_COSTUME, nil, "Costume" },
		{ ITEMTYPE_DISGUISE, nil, "Disguise" },
		{ ITEMTYPE_DRINK, nil, "Drink" },
		{ ITEMTYPE_ENCHANTMENT_BOOSTER, nil, "Enchantment (Booster)" },
		{ ITEMTYPE_ENCHANTING_RUNE, nil, "Enchanting (Rune)" },
		{ ITEMTYPE_FLAVORING, nil, "Flavoring" },
		{ ITEMTYPE_FOOD, nil, "Food" },
		{ ITEMTYPE_GLYPH_JEWELRY, nil, "Jewelery (Glyph)" },
		{ ITEMTYPE_LOCKPICK, nil, "LockPick" },
		{ ITEMTYPE_LURE, nil, "Lure" },
		{ ITEMTYPE_NONE, nil, "None" },
		{ ITEMTYPE_PLUG, nil, "Plug" },
		{ ITEMTYPE_POISON, nil, "Poison" },
		{ ITEMTYPE_POTION, nil, "Potion" },
		{ ITEMTYPE_INGREDIENT, nil, "Provisioning" },
		{ ITEMTYPE_RAW_MATERIAL, nil, "Raw Material" },
		{ ITEMTYPE_REAGENT, nil, "Reagent" },
		{ ITEMTYPE_RECIPE, nil, "Recipe" },
		{ ITEMTYPE_AVA_REPAIR, nil, "Repair" },
        { ITEMTYPE_SCROLL, nil, "Scroll" },
	    { ITEMTYPE_SIEGE, nil, "Siege" },
		{ ITEMTYPE_SOUL_GEM, nil, "Soul Gem" },
		{ ITEMTYPE_SPICE, nil, "Spice" },
		{ ITEMTYPE_STYLE_MATERIAL, nil, "Style Material" },
		{ ITEMTYPE_TABARD, nil, "Tabard" },
		{ ITEMTYPE_TOOL, nil, "Tool" },
		{ ITEMTYPE_TRASH, nil, "Trash" },
		{ ITEMTYPE_TROPHY, nil, "Trophy" },
	    { ITEMTYPE_WEAPON, nil, "Weapon" },
		{ ITEMTYPE_WEAPON_BOOSTER, nil, "Weapon (Booster)" },
		{ ITEMTYPE_GLYPH_WEAPON, nil, "Weapon (Glyph)" },
		{ ITEMTYPE_WEAPON_TRAIT, nil, "Weapon (Trait Stone)" },
		{ ITEMTYPE_WOODWORKING_BOOSTER, nil, "Woodworking (Booster)" },
		{ ITEMTYPE_WOODWORKING_MATERIAL, nil, "Woodworking (Material)" },
		{ ITEMTYPE_WOODWORKING_RAW_MATERIAL, nil, "Woodworking (Raw Material)" },

    }

    local function SelectMatType(_, _, entry)
        self.m_craftType = entry.minValue
    end

    ZO_TradingHouse_InitializeRangeComboBox(control:GetNamedChild("Category"), typeData, SelectMatType)
end

function BatmanFilter:ApplyToSearch(search)
    search:SetFilter(TRADING_HOUSE_FILTER_TYPE_ITEM, self.m_craftType)
end

ZO_TradingHouse_RegisterSearchFilter(BatmanFilter, SI_TRADING_HOUSE_BROWSE_ITEM_TYPE_CRAFTING_MATERIALS)
